\section{Deep learning architectures}
\subsection{Recurrent Neural Networks}
\begin{frame}
	\frametitle{RNN and GRU Cell}
	At each time step $t$, the RNN Cell can be computed as follows:
	$$
		h_t = \tanh(A h_{t-1} + B u_t + b)
	$$

	The Gated Recurrent Unit (GRU) Cell is computed as follows:
	\begin{align*}
		\Gamma_r   & = \sigma(W_{xr} u_t + W_{hr} h_{t-1} + b_r)\,,           \\
		\Gamma_z   & = \sigma(W_{xz} u_t + W_{hz} h_{t-1} + b_z)\,,           \\
		\tilde h_t & = \tanh(W_{xh} u_t + \Gamma_r * W_{hh} h_{t-1} + b_c)\,, \\
		% c_t      & = \Gamma_f * c_{t-1} + \Gamma_i * \tilde c_t\,,          \\
		h_t        & = (1 - \Gamma_z) * h_{t-1} + \Gamma_z * \tilde h_t \,.
	\end{align*}
\end{frame}

\begin{frame}
	\frametitle{LSTM Cell}
	At each time step $t$, the LSTM Cell can be computed as follows:
	\begin{align*}
		\Gamma_i   & = \sigma(W_{xi} u_t + W_{hi} h_{t-1} + b_i)\,,  \\
		\Gamma_f   & = \sigma(W_{xf} u_t + W_{hf} h_{t-1} + b_f)\,,  \\
		\Gamma_o   & = \sigma(W_{xo} u_t + W_{ho} h_{t-1} + b_o)\,,  \\
		\tilde c_t & = \tanh(W_{xc} u_t + W_{hc} h_{t-1} + b_c)\,,   \\
		c_t        & = \Gamma_f * c_{t-1} + \Gamma_i * \tilde c_t\,, \\
		h_t        & = \Gamma_o * \tanh c_t\,.
	\end{align*}
\end{frame}

\subsection{Transformer}
\begin{frame}
	\frametitle{Transformer - Concept}
	Transformer were introduced for NLP as an alternative to sequential models. They rely on \textbf{attention mechanisms} to address the lack of long term memory of LSTM.
	\begin{itemize}
		\item Sequences are \alert{computed in parallel}.
		      \vspace{.2cm}
		\item Complexity is in \alert{$\mathcal{O}(T^2 \cdot n)$}.
		      \vspace{.2cm}
		\item Memory is replaced by \alert{attention}.
	\end{itemize}{}
\end{frame}{}

\begin{frame}
	\frametitle{Self attention mechanism}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.5\textwidth]{images/metamodel/MHA.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Self attention mechanism}
	\begin{align*}
		Q               & = W_q x                  & (T, q) \quad & \texttt{Queries} \\
		K               & = W_k x                  & (T, k) \quad & \texttt{Keys}    \\
		V               & = W_v x                  & (T, v) \quad & \texttt{Values}  \\
		\texttt{Scores} & = \frac{Q K^T}{\sqrt{q}} & (T, T)
	\end{align*}
	With the softmax function $\texttt{softmax}(z) \mapsto \frac{e^{z_i}}{\sum_j {e^{z_j}}}$ :
	\begin{block}{Attention}
		$$Attention = \texttt{softmax}(\frac{Q \cdot K}{\sqrt{d_k}}) V $$
	\end{block}
\end{frame}{}

\begin{frame}
	\frametitle{Full Transformer architecture}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.4\textwidth]{images/metamodel/illustration_encoder_decoder.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Attention maps}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.5\textwidth]{images/metamodel/illustration_attention_map.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Attention maps}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.5\textwidth]{images/metamodel/attentionmap.png}
	\end{figure}
\end{frame}

\section{Metamodelling}
\subsection{TRNSYS}
\begin{frame}
	\frametitle{TRNSYS}
	\begin{figure}
		\centering
		\includegraphics[width=0.65\textwidth]{images/oze/trnsys_usage.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{TRNSYS simulation sample}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.8\textwidth]{images/oze/TRNSYS_simulation.png}
	\end{figure}
\end{frame}

\subsection{Dataset}
\begin{frame}
	\frametitle{Training samples - Inputs}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=\textwidth]{images/metamodel/dataset_input.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Training samples - Outputs}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=\textwidth]{images/metamodel/dataset_output.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Weather data}
	\begin{table}[ht]
		\centering
		\begin{tabular}{*2c}
			Variable & Description                   \\
			\hline
			DNI      & Direct Normal Irradiance      \\
			IBEAM\_H & Direct Horizontal Irradiance  \\
			IBEAM\_N & Direct Normal Irradiance      \\
			IDIFF\_H & Diffuse Horizontal Irradiance \\
			IGLOB\_H & Global Horizontal Irradiance  \\
			RHUM     & Outdoor Relative Humidity     \\
			TAMB     & Outdoor temperature           \\
			\hline                                   \\
		\end{tabular}
	\end{table}
\end{frame}


\subsection{Training}
\begin{frame}
	\frametitle{Training samples}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.55\textwidth]{images/metamodel/metamodel_training_visuals.jpg}
	\end{figure}
\end{frame}

\section{Calibration and Optimization}
\begin{frame}
	\frametitle{Calibration (Stanley)}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.6\textwidth]{images/calib-optim/calib_stanley_comp_t_int.png}
		\includegraphics[width=0.6\textwidth]{images/calib-optim/calib_stanley_comp_elec.png}
	\end{figure}
\end{frame}


\begin{frame}
	\frametitle{Calibration (Livingstone)}
	\begin{figure}[htpb]
		\centering
		\caption{Consumption and temperature simulations after calibration, for both the metamodel and TRNSYS, for Livingstone.}
		\includegraphics[width=0.6\textwidth]{images/calib-optim/calib_livingstone_comp_t_int.png}
		\includegraphics[width=0.6\textwidth]{images/calib-optim/calib_livingstone_comp_elec.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Optimization (Livingstone)}
	\begin{figure}[htpb]
		\centering
		\includegraphics[width=0.6\textwidth]{images/calib-optim/optim_livingstone_tint.png}
		\includegraphics[width=0.6\textwidth]{images/calib-optim/optim_livingstone_elec.png}
	\end{figure}
\end{frame}

\section{Uncertainty estimation}
\subsection{Sequential Monte Carlo}
\begin{frame}
	\frametitle{Confidence intervals}
	\begin{figure}[htpb]
		\centering
		\caption{Prediction of relative humidity given observations in the lookback window ($t<24$) and without ($t>24$).
			Since re sampling of particles is no longer available after $t=24$, the uncertainty grows as the confidence intervals get larger over time.}
		\includegraphics[width=0.7\linewidth]{images/airq/lastlayer/ci_growing.png}
	\end{figure}
\end{frame}

\subsection{Variational Inference}
\begin{frame}
	\frametitle{Variational Inference - Re parametrization trick}
	We express $z$ as a differentiable function $g$ of the parameter $\phi$ and some independent random variable $\epsilon$, such that \textcolor{teal}{$z = g_\phi(y, \epsilon)$}.
	\begin{align*}
		\textcolor{violet}{\nabla_\phi \elbo_{\theta, \phi} (y)}
		 & = \nabla_\phi \expectation \left[ \log \frac{p_\theta(y|\textcolor{teal}{z}) p_\theta(\textcolor{teal}{z})}{q_\phi(\textcolor{teal}{z} | y)} \right]                                                                  \\
		 & = \mathbb{E}_{p_\epsilon} \nabla_\phi \left[ \log \frac{p_\theta(y|\textcolor{teal}{g_\phi(y, \epsilon)}) p_\theta(\textcolor{teal}{g_\phi(y, \epsilon)})}{q_\phi(\textcolor{teal}{g_\phi(y, \epsilon)} | y)} \right]
	\end{align*}
	\begin{figure}
		\centering
		\includegraphics[width=0.5\textwidth]{images/airq/vadiltis/reparametrization.png}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Gumbel Softmax for Categorical variables}
	\begin{figure}
		\centering
		\includegraphics[width=0.8\textwidth]{images/airq/vadiltis/gumbel_softmax.png}
	\end{figure}
\end{frame}

\subsection{Diffusion bridge priors}
\begin{frame}
	\frametitle{Diffusion Bridge}
	\begin{figure}[h]
		\centering
		\includegraphics[width=0.8\linewidth]{images/diffusion-bridges/archi.png}
		\caption{Our proposed architecture, for a prior based on a Ornstein-Uhlenbeck bridge. The top pathway from \textit{input image} to $\encoding^0$, to $\quantized^0$, to \textit{reconstructed image} resembles the original VQ-VAE model. The vertical pathway from $(\encoding^0, \quantized^0)$ to $(\encoding^T, \quantized^T)$ and backwards is based on a denoising diffusion process.}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Noising and de-noising process - toy example}
	\begin{figure}
		\centering
		\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/toy/forward_backward_sequence.png}
		\caption{(Left) Forward noise process for one sample. First, one data is drawn ($\encoding^0 =y$ in the toy example) and then $\{\encoding^t\}_{1\leq t \leq T}$ are sampled under $q_\phi$ and displayed. % corresponding to the discrete sequence $[7,0,1,2,3]$:
		%$X^t_s$ is represented for $0 \leq t \leq 50$ and $s$ the displayed index.
		(Right) Reverse process for one sample $\encoding^T\sim \mathcal{N}(0, (2\vartheta)^{-1}\eta^2 \mathbf{I}_{dN})$. As expected, the last sample $\encoding^0$ reaches the neighborhood of $5$ codebooks.}
		%Generated samples have the same underlying discrete structure as the original generation procedure: the generated $X^0_s$ can be discretized by finding the nearest neighbour codebook into the following sequence $(5,6,5,4,3)$. Discrete sequences alongside the process can be found in Appendix~\ref{ap:discretetoy}} %It generates a valid sequence $[5,6,5,4,3]$.}
	\end{figure}
\end{frame}

\begin{frame}
	\frametitle{Sampling from the diffusion bridge prior}
	\begin{figure}
		\centering
		\includegraphics[width=0.9\linewidth]{images/diffusion-bridges/sampling_chain.png}
		\caption{Sampling denoising chain from $t=500$ up to $t=0$, shown at regular intervals.}
	\end{figure}
\end{frame}
